---
title: CanvasRenderingContext2D.createImageData()
slug: Web/API/CanvasRenderingContext2D/createImageData
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D.createImageData()</strong></code> method of the Canvas 2D API creates a new, blank {{domxref("ImageData")}} object with the specified dimensions. All of the pixels in the new object are transparent black.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">ImageData <em>ctx</em>.createImageData(<em>width</em>, <em>height</em>);
ImageData <em>ctx</em>.createImageData(<em>imagedata</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>width</code></dt>
 <dd>The width to give the new <code>ImageData</code> object. A negative value flips the rectangle around the vertical axis.</dd>
 <dt><code>height</code></dt>
 <dd>The height to give the new <code>ImageData</code> object. A negative value flips the rectangle around the horizontal axis.</dd>
 <dt><code>imagedata</code></dt>
 <dd>An existing <code>ImageData</code> object from which to copy the width and height. The image itself is <strong>not</strong> copied.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("ImageData")}} object with the specified width and height. The new object is filled with transparent black pixels.</p>

<h3 id="Errors_thrown">Errors thrown</h3>

<dl>
 <dt><code>IndexSizeError</code></dt>
 <dd>Thrown if either of the <code>width</code> or <code>height</code> arguments is zero.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_blank_ImageData_object">Creating a blank ImageData object</h3>

<p>This snippet creates a blank <code>ImageData</code> object using the <code>createImageData()</code> method.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The generated object is 100 pixels wide and 50 pixels tall, making 5,000 pixels in all. Each pixel within an <code>ImageData</code> object consists of four array values, so the object's {{domxref("ImageData.data", "data")}} property has  a length of 4 × 5,000, or 20,000.</p>

<pre class="brush: js; highlight:[4]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

const imageData = ctx.createImageData(100, 50);
console.log(imageData);
// ImageData { width: 100, height: 50, data: Uint8ClampedArray[20000] }
</pre>

<h3 id="Filling_a_blank_ImageData_object">Filling a blank ImageData object</h3>

<p>This example creates and fills a new <code>ImageData</code> object with purple pixels.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<p>Since each pixel consists of four values, the <code>for</code> loop iterates by multiples of four. The array values associated with each pixel are R (red), G (green), B (blue), and A (alpha), in that order.</p>

<pre class="brush: js">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
const imageData = ctx.createImageData(100, 100);

// Iterate through every pixel
for (let i = 0; i &lt; imageData.data.length; i += 4) {
  // Modify pixel data
  imageData.data[i + 0] = 190;  // R value
  imageData.data[i + 1] = 0;    // G value
  imageData.data[i + 2] = 210;  // B value
  imageData.data[i + 3] = 255;  // A value
}

// Draw image data to the canvas
ctx.putImageData(imageData, 20, 20);</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Filling_a_blank_ImageData_object", 700, 180)}}</p>

<h3 id="More_examples">More examples</h3>

<p>For more examples using <code>createImageData()</code> and the <code>ImageData</code> object, see <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Pixel_manipulation_with_canvas">Pixel manipulation with canvas</a> and {{domxref("ImageData.data")}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-createimagedata", "CanvasRenderingContext2D.createImageData")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.createImageData")}}</p>

<h3 id="Gecko-specific_notes">Gecko-specific notes</h3>

<ul>
 <li>Starting with {{geckoRelease("5.0")}}:
  <ul>
   <li><code>createImageData()</code> now correctly returns at least one pixel's worth of image data if a rectangle smaller than one pixel is specified.</li>
   <li>Specifying non-finite values when calling <code>createImageData()</code> now properly throws a <code>NOT_SUPPORTED_ERR</code> exception.</li>
   <li><code>createImageData()</code> now handles negative arguments in accordance with the specification, by flipping the rectangle around the appropriate axis.</li>
  </ul>
 </li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("ImageData")}}</li>
 <li><a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Pixel_manipulation_with_canvas">Pixel manipulation with canvas</a></li>
</ul>
